.include "pat_spiral.s"
.include "pat_pinwheel.s"
.include "pat_tunnel.s"
.include "pat_snakes.s"
.include "pat_vert_comb.s"
.include "pat_swirl.s"
.include "pat_horiz_comb.s"
.include "pat_stars.s"
.include "pat_stripes.s"
.include "trans_wipes.s"

init_catalog:
	rts

; Generates random pattern index
; Out: A = index
rand_pat_index:
:       jsr random
	and #$1F
	cmp sram_pat_list_len
	bge :-
	pha
	jsr get_pat_ptr
	pla
	tax
	lda addr
	cmp pat_ptr
	bne :+
	lda addr+1
	cmp pat_ptr+1
	beq :-
:       txa
	rts
	
; Sets and initializes pattern
; In: A = index
:       jsr rand_pat_index
init_pat_index:
	cmp sram_pat_list_len
	blt :+
	internal_error 5
	bne :-
:
	sta cur_pat_index
	
	jsr get_pat_ptr
init_pat_addr:
	movw pat_ptr,addr
	jmp init_pat

init_direct_pat_index:
	cmp #sram_fixed_pats_len
	blt :+
	internal_error 6
	lda #0
:
	jsr get_fixed_pat_ptr
	jmp init_pat_addr
	

; Sets and initializes random transition
init_rand_trans:
:       jsr random
	and #$0F
	cmp #trans_table_size
	bge :-

; Sets and initializes transition
; In: A = index
init_trans_index:
	cmp #trans_table_size
	blt :+
	rts
	
:       asl a
	tax
	
	mov trans_ptr+0, {trans_table+0,x}
	mov trans_ptr+1, {trans_table+1,x}
	
	jmp init_trans

trans_table:
	.word trans_vert_comb
	.word trans_wipe_down_right
	.word trans_wipe_up_left
	.word trans_wipe_right
	.word trans_wipe_left
	.word trans_wipe_down
	.word trans_wipe_up
	.word trans_expanding_spiral
	.word trans_contracting_spiral
	.word trans_dissolve
trans_table_size = (* - trans_table) / 2
