; Configuration screens

.include "console.s"
.include "pat_list_editor.s"
.include "pat_list.s"

config_pat_list:
	jsr config_init_screen
	jsr use_pat_list
	movw addr,#@title
	jsr edit_pat_list
	jsr save_pat_lists
	jsr verify_pat_lists
	rts

@title:
	.byte "Select patterns and order",0

config_fixed_pats:
	jsr config_init_screen
	jsr @draw_labels
	jsr use_direct_pat_list
	movw addr,#@title
	jsr edit_pat_list
	jsr save_pat_lists
	rts

@title:
	.byte "Select direct patterns",0

@draw_labels:
	ldx #pat_list_y
	ldy #0
@loop:  txa
	jsr move_to_line
	ora #2
	sta VADDR
	
	jmp @first
:       sta VDATA
	iny
@first: lda @strs,y
	bne :-
	iny
	
	inx
	cpx #pat_list_y + sram_fixed_pats_len
	bne @loop
	
	rts

@strs:
	.byte "U",0
	.byte "D",0
	.byte "L",0
	.byte "R",0
	.byte "U x2",0
	.byte "D x2",0
	.byte "L x2",0
	.byte "R x2",0
	.byte "First",0

poll_joy:
	jsr wait_vbl
	jsr read_joy
	jsr update_joy
	jsr repeat_joy
	rts

; Draws string, padded with spaces
; In: addr = str
;     A = desired length
draw_str_padded:
	pha
	jsr draw_str
	pla
	sta temp
	jmp @first
:       mov VDATA,#' '
	iny
@first: cpy temp
	blt :-
	rts

; Draws string
; In: addr = str
; Out: Y = len
draw_str:
	ldy #0
	jmp @first
:       sta VDATA
	iny
@first: lda (addr),y
	bne :-
	rts

