; Unsigned 32/16=16 16 division
; In: 32-bit dividend
;     16-bit divisor
; Out: 16-bit quotient
;      16-bit remainder
; Time: ~1300 cycles max
zp_res dividend,4
zp_res divisor,2
quotient = dividend
remainder = dividend+2

div32:  ; Overflow if dividend/65536 >= divisor
	lda dividend+2
	cmp divisor+0
	lda dividend+3
	sbc divisor+1
	bcs @overflow
	
	ldx #17
:       rol dividend+0
	rol dividend+1
	
	dex
	beq @done

	rol dividend+2
	rol dividend+3
	lda #$80
	rol a           ; $00/$01 based on carry
;       sec             ; done by prev instr
	pha
	
	lda dividend+2
	sbc divisor+0
	sta temp
	
	lda dividend+3
	sbc divisor+1
	tay
	
	pla
	adc #$FF
	
	bcc :-
	
	lda temp
	sta dividend+2
	sty dividend+3
	
	jmp :-

@overflow:
	lda #$FF
	sta dividend+2
	sta dividend+3
	sta dividend+0
	sta dividend+1
	
@done:  rts
