; Snake that randomly moves around

snakes_count = 4

zp_res snakes_x,snakes_count
zp_res snakes_y,snakes_count
bss_res snakes_dir,snakes_count
bss_res snakes_remain,snakes_count

pat_snakes:
	.word 0
	.word snakes_init
	.word snakes_draw

snakes_init:
	ldx #snakes_count - 1
:       lda snakes_dir,x
	and #$03
	sta snakes_dir,x
	
	lda snakes_x,x
	and #$07
	sta snakes_x,x
	
	lda snakes_y,x
	and #$07
	sta snakes_y,x
	
	mov {snakes_x,x},#5
	mov {snakes_y,x},#4
	
	mov {snakes_remain,x},#3
	
	dex
	bpl :-
	
	rts


snakes_move:
	lda snakes_dir,x
	tay
	
	dec snakes_remain
	beq @wall
	
@try_again:
	lda @x_dirs,y
	clc
	adc snakes_x,x
	cmp #cols
	bge @wall
	sta temp

	lda @y_dirs,y
	clc
	adc snakes_y,x
	cmp #rows
	bge @wall
	
	sta snakes_y,x
	tya
	sta snakes_dir,x
	lda temp
	sta snakes_x,x
	
	rts

@wall:
	jsr @new_dir
	jmp @try_again

@new_dir:
	jsr random
	tay
	
	lsr
	lsr
	and #$03
	adc #3
	sta snakes_remain,x
	
	tya
	and #$02
	sec
	sbc #1
	
	clc
	adc snakes_dir,x
	and #$03
	tay
	
	rts
	
@x_dirs:
	.byte -1, 0, +1, 0
@y_dirs:
	.byte 0, -1, 0, +1


snakes_draw:
	lda anim_count
	bne @anim
	rts
	
@anim:  lda anim_hue
	ora #$07
	sta temp2
	
	ldx #snakes_count - 1
:       jsr snakes_move
	lda snakes_x,x
	asl
	asl
	asl
	ora snakes_y,x
	tay
	lda temp2
	clc
	adc #$10
	sta temp2
	sta lw_colors,y
	dex
	bpl :-
	
	dec anim_count
	bne @anim
	
	jmp darken_canvas
