; Pattern interface

pat_info = 0    ; flags describing pattern
pat_init = 2    ; Called once before displaying
pat_draw = 4    ; Called when frame can be updated

pat_info_writeonly = $0001 ; never reads from lw_colors
pat_info_stack     = $0002 ; uses only begin_stack_drawing
pat_info_notrans   = $0100 ; always change immediately

; Pointer to current pattern
zp_res pat_ptr,2

init_pattern:
	movw pat_ptr,#pat_black
	rts

.macro jmp_proc Ptr
	mov addr, {(Ptr),y}
	iny
	mov addr+1, {(Ptr),y}
	jmp (addr)
.endmacro

init_pat:
	ldy #pat_init
	jmp call_pat

draw_pat:
	ldy #pat_draw
call_pat:
	jmp_proc pat_ptr


null_proc:
	rts


; All-black pattern
pat_black:
	.word pat_info_stack
	.word null_proc
	.word draw_black

draw_black:
	begin_stack_drawing
	lda #0
	ldx #cols * pitch - 1
:       pha
	dex
	bpl :-
	end_stack_drawing
	rts
