; Renders pattern info buffer

; Space below lw_colors for pushing on stack, AND so that you can subtract
; from lw_colors without if going into the previous page, and then have
; your index go from 128-cols*pitch to 128, making the loop more efficient.
sp_res lw_colors_extra,128 - cols*pitch - 11

; Image buffers cols x rows big, indexed via X*pitch + Y
; lw_colors has extra columns on left and right, to allow
; writing last the edges for convenience.
.bss
.align 128
.code
bss_res lw_palsel,cols * pitch  ; palette select
sp_res lw_colors,(cols + 1) * pitch

; Second screen used for transitions, here to ensure it's immediately
; after lw_colors
sp_res lw_colors2,cols * pitch

; Support for stack-based drawing, which can be faster

lw_colors_stack_top  = <(lw_colors + cols*pitch - 1)

bss_res saved_s
bss_res stack_buffer

; During stack drawing, routines can still be called.

; Begins drawing using stack
.macro begin_stack_drawing
	tsx
	stx saved_s
	ldx stack_buffer
	txs
.endmacro

; Ends stack drawing
.macro end_stack_drawing
	ldx saved_s
	txs
.endmacro

; Initializes module
init_rendering:
	; Clear all squares to black
	ldx #cols*pitch - 1
	lda #0
:       sta lw_palsel,x
	sta lw_colors,x
	dex
	bpl :-
	
	@offset = (cols - lw_cols) * pitch / 2
	movw lw_palsel_ptr,#lw_palsel + @offset
	movw lw_colors_ptr,#lw_colors + @offset
	mov stack_buffer,#lw_colors_stack_top
	
	rts

; Renders single pattern to frame
render_frame:
	jsr confirm_litewall_update
	jsr draw_pat
	jmp request_litewall_update
