; Darkens all blocks one level. Any that reach zero are
; blackened.
darken_canvas:
	sec
	ldx #cols * pitch - 1
:       lda lw_colors,x
	and #$07
	beq @black
	lda lw_colors,x
	sbc #1
@black: sta lw_colors,x
	dex
	bpl :-
	rts

darken_canvas_diag:
	mov lw_colors,#0
	sec
	ldx #cols * pitch - 1
:       ldy @table,x
	lda lw_colors,y
	and #$07
	beq @black
	lda lw_colors,y
	sbc #1
@black: sta lw_colors,x
	dex
	bpl :-
	rts

@table:
    .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$02,$03,$04,$05,$06
    .byte $00,$08,$09,$0A,$0B,$0C,$0D,$0E,$00,$10,$11,$12,$13,$14,$15,$16
    .byte $00,$18,$19,$1A,$1B,$1C,$1D,$1E,$00,$20,$21,$22,$23,$24,$25,$26
    .byte $00,$28,$29,$2A,$2B,$2C,$2D,$2E,$00,$30,$31,$32,$33,$34,$35,$36
    .byte $00,$38,$39,$3A,$3B,$3C,$3D,$3E,$00,$40,$41,$42,$43,$44,$45,$46

darken_canvas_right:
	sec
	ldx #(cols - 1) * pitch - 1
:       lda lw_colors,x
	and #$07
	beq @black
	lda lw_colors,x
	sbc #1
@black: sta lw_colors + pitch,x
	dex
	bpl :-

	lda #0
	ldx #pitch - 1
:       sta lw_colors,x
	dex
	bpl :-

	rts

lighten_wrap_canvas:
	ldx #cols * pitch - 1
:       lda lw_colors,x
	and #$07
	beq @black
	lda lw_colors,x
	clc
	adc #1
@black: sta lw_colors,x
	dex
	bpl :-
	rts

lighten_wrap_canvas_right:
	ldx #(cols - 1) * pitch - 1
:       lda lw_colors,x
	and #$07
	beq @black
	lda lw_colors,x
	clc
	adc #1
@black: sta lw_colors + pitch,x
	dex
	bpl :-

	lda #0
	ldx #pitch - 1
:       sta lw_colors,x
	dex
	bpl :-

	rts

lighten_wrap_canvas_down:
	ldx #cols * pitch - 2
:       ldy #rows - 1
:       lda lw_colors,x
	and #$07
	beq @black
	lda lw_colors,x
	clc
	adc #1
@black: sta lw_colors + 1,x
	dex
	dey
	bne :-
	dex
	bpl :--

	lda #0
	.repeat cols,i
	sta lw_colors + i * pitch
	.endrepeat

	rts

.macro warp_canvas_fwd Table
	@offset = cols*pitch - 128
	ldx #@offset
:       ldy Table - @offset,x
	lda lw_colors - @offset,y
	sta lw_colors - @offset,x
	inx
	bpl :-
.endmacro

.macro warp_canvas_rev Table
	ldx #cols * pitch - 1
:       ldy Table,x
	lda lw_colors,y
	sta lw_colors,x
	dex
	bpl :-
.endmacro

; Generates random coordinate (0 to cols*pitch-1)
; Out: A = coordinate
; Time: 80 cycles average, indefinite in worst case
random_xy:
:       jsr random
	sec
	sbc #80
	bcc :+
	sbc #80
	bcc :+
	sbc #80
	bcs :-
:       adc #80
	rts

.align 256
spiral:
    .byte $07,$06,$05,$04,$03,$02,$01,$00,$08,$10,$18,$20,$28,$30,$38,$40
    .byte $48,$49,$4A,$4B,$4C,$4D,$4E,$4F,$47,$3F,$37,$2F,$27,$1F,$17,$0F
    .byte $0E,$0D,$0C,$0B,$0A,$09,$11,$19,$21,$29,$31,$39,$41,$42,$43,$44
    .byte $45,$46,$3E,$36,$2E,$26,$1E,$16,$15,$14,$13,$12,$1A,$22,$2A,$32
    .byte $3A,$3B,$3C,$3D,$35,$2D,$25,$1D,$1C,$1B,$23,$2B,$33,$34,$2C,$24
