; NES-specific text screen routines

; Place to write low byte of nametable address after calling
; move_to_line
VADDR   = $2006

; Register to write bytes to nametable
VDATA   = $2007

; Begins updating nametable
begin_update:
	pha
	jsr wait_vbl
	mov PPUMASK,#0
	pla
	rts

; Ends updating nametable
end_update:
	lda #0
	sta PPUSCROLL
	sta PPUSCROLL
	mov PPUMASK,#PPUMASK_BG0
	rts

; Initializes to black screen
config_init_screen:
	jsr wait_vbl
	jsr wait_vbl
	mov PPUCTRL,#0
	mov PPUMASK,#0
	
	jsr wait_vbl
	jsr load_palette
	jsr clear_nametable
	
	rts

; Enables screen rendering
config_enable_screen:
	jsr wait_vbl
	mov PPUMASK,#PPUMASK_BG0
	mov PPUSCROLL,#0
	mov PPUSCROLL,#0
	mov PPUCTRL,#0
	rts

; Moves to line
; In: A = line, from 0 to 29
move_to_line:
	asl a
	asl a
	asl a
	asl a
	sta temp
	lda #$20 >> 2
	rol a
	asl temp
	rol a
	sta PPUADDR
	lda temp
	rts

; Loads palette
load_palette:
	mov PPUADDR,#$3F
	mov PPUADDR,#$00
	ldy #0
:       mov PPUDATA, {@palette,y}
	iny
	cpy #32
	bne :-
	rts

@palette:
	.byte $0F,$30,$30,$30
	.byte $0F,$30,$30,$30
	.byte $0F,$30,$30,$30
	.byte $0F,$30,$30,$30

	.byte $0F,$30,$30,$30
	.byte $0F,$30,$30,$30
	.byte $0F,$30,$30,$30
	.byte $0F,$30,$30,$30
	
; Clears nametable to tile 0
clear_nametable:
	mov PPUADDR,#$20
	mov PPUADDR,#$00
	ldy #0
	lda #0
:       sta PPUDATA
	sta PPUDATA
	sta PPUDATA
	sta PPUDATA
	iny
	bne :-
	rts

; Waits until beginning of VBL
wait_vbl:
	bit PPUSTATUS
:       bit PPUSTATUS
	bpl :-
	rts
