; SNES-specific text screen routines
; See NES version for documentation

VADDR   = VMADDL
VDATA   = VMDATAL

nametable = $2000

begin_update:
	pha
	jsr wait_vbl
	mov INIDISP,#$80
	stz VMAIN
	pla
	rts

end_update:
	mov INIDISP,#$0F
	rts

config_init_screen:
	jsr init_ppu_regs
	jsr blacken_palette
	jsr load_palette
	jsr clear_nametable
	jsr load_ascii_chr
	stz VMAIN
	rts

config_enable_screen:
	jsr wait_vbl
	mov BG1SC,#>nametable
	mov TM,#$01
	mov INIDISP,#$0F
	rts

move_to_line:
	asl a
	asl a
	asl a
	asl a
	sta temp
	lda #nametable >> 10
	rol a
	asl temp
	rol a
	sta VMADDH
	lda temp
	rts

load_palette:
	stz CGADD
	ldy #0
:       lda @palette,y
	sta CGDATA
	iny
	cpy #@palette_size
	bne :-
	rts

@palette:
	.word $0000,$7FFF,$7FFF,$7FFF
@palette_size = * - @palette

clear_nametable:
	mov VMAIN,#$80
	movw VMADDL,#nametable
	lda #0
:       stz VMDATAL
	stz VMDATAH
	stz VMDATAL
	stz VMDATAH
	stz VMDATAL
	stz VMDATAH
	stz VMDATAL
	stz VMDATAH
	inc
	bne :-
	rts

load_ascii_chr:
	native_routine
	
	mov VMAIN,#$80
	movw VMADDL,#0
	
	ldx #0
:       lda @ascii,x
	sta VMDATAL
	sta VMDATAH
	inx
	cpx #128 * 8
	bne :-
	
	native_rts

@ascii: .res 32 * 8,0
	.incbin "ascii.chr"
