; Displays 10x8 grid of colored squares, each with a settable color.

rows = 8        ; number of rows, <= 8, lower gives more time outside of NMI
pitch = rows    ; number of bytes to next column, must be >= rows

zp_res  lw_joy          ; Currently pressed buttons, updated every NMI
bss_res lw_rand_seed    ; Incremented when waiting for update

lw_max_shapes = 4

.include "lw_init.s"

lw_nametable = $6000
lw_palsel_mask = $03

zp_res  lw_colors_ptr,2
zp_res  lw_palsel_ptr,2
bss_res lw_buf,4 * 8 * 4 * 2
zp_res  lw_bgcolor
bss_res lw_shape_nt

snes_wait_vbl:
:       inc lw_rand_seed
	bit HVBJOY
	bmi :-
	
:       inc lw_rand_seed
	bit HVBJOY
	bpl :-
	
	rts

init_litewall:
	native_routine
	
	jsr lw_init
	
	lda #0
	jsr set_litewall_shape
	
	mov lw_bgcolor,#$0F
	
	jsr snes_wait_vbl
	mov NMITIMEN,#$80
	
	native_rts

zp_res joy_temp

lw_nmi_15:
	lda lw_shape_nt
	sta BG1SC
	sta BG2SC
	sta BG3SC
	sta BG4SC
	
	; Strobe controller
	lda #1
	sta $4016
	lda #0
	sta $4016
	
	; Read 8 bits
	lda #$80
:       pha
	lda $4016+ADDR
	lsr
	pla
	ror
	bcc :-
	
	sta lw_joy
	rts

confirm_litewall_update:
	rts

set_litewall_shape:
	tax
	lda @nametables,x
	sta lw_shape_nt
	rts

@nametables:
	.byte >(lw_nametable + nt_size*0)
	.byte >(lw_nametable + nt_size*1)
	.byte >(lw_nametable + nt_size*2)
	.byte >(lw_nametable + nt_size*3)
	.byte >(lw_nametable + nt_size*0)
	.byte >(lw_nametable + nt_size*1)
	.byte >(lw_nametable + nt_size*2)
	.byte >(lw_nametable + nt_size*3)
	.byte >(lw_nametable + nt_size*4)
	.byte >(lw_nametable + nt_size*5)
	.byte >(lw_nametable + nt_size*6)
	.byte >(lw_nametable + nt_size*7)
	.byte >(lw_nametable + nt_size*4)
	.byte >(lw_nametable + nt_size*5)
	.byte >(lw_nametable + nt_size*6)
	.byte >(lw_nametable + nt_size*7)

set_litewall_bgcolor:
	sta lw_bgcolor
	rts

stop_litewall:
	jsr wait_vbl
	mov INIDISP,#$80
	stz TM
	stz NMITIMEN
	stz BG12NBA
	stz BG34NBA
	rts

update_litewall:
request_litewall_update:
	native_routine
	
	ldy #0
	
	ldx #2
	jsr @col
	
	ldx #4
	jsr @col
	
	ldx #6
	jsr @col
	
	ldx #10
	jsr @col
	
	ldx #12
	jsr @col
	
	ldx #14
	jsr @col
	
	ldx #18
	jsr @col
	
	ldx #20
	jsr @col
	
	ldx #22
	jsr @col
	
	ldx #26
	jsr @col
	
	jsr snes_wait_vbl
	
	lda #0
	xba
	lda lw_bgcolor
	and #$3F
	asl
	tax
	ldy nes_palette,x
	sty lw_buf
	
	stz CGADD
	ldx #0
:       lda lw_buf,x
	inx
	sta CGDATA
	lda lw_buf,x
	inx
	sta CGDATA
	cpx #4 * 8 * 4 * 2
	blt :-
	
	native_rts

.macro lw_conv_col Offset
	lda (lw_palsel_ptr),y
	and #lw_palsel_mask
	xba
	lda (lw_colors_ptr),y
	iny
	a16
	asl
	tax
	lda lw_palette,x
	ldx temp
	sta lw_buf + Offset * 2,x
	a8
.endmacro

@col:
	stx temp
	lw_conv_col 0
	lw_conv_col $20
	lw_conv_col $10
	lw_conv_col $30
	lw_conv_col $40
	lw_conv_col $60
	lw_conv_col $50
	lw_conv_col $70
	rts
	
nes_palette:
        .word $318C,$40A0,$5042,$5007,$3C0B,$200D,$000D,$006A
        .word $00C6,$0121,$0140,$0120,$2500,$0000,$0000,$0000
        .word $56B5,$6D62,$7CE8,$7C8E,$6474,$3C77,$10D6,$0133
        .word $01AD,$0207,$0241,$1A20,$45E0,$0000,$0000,$0000
        .word $7FFF,$7ECC,$7E52,$7DD8,$7DBE,$65BF,$3A1F,$127D
        .word $02F7,$0371,$178B,$4388,$6F28,$2529,$0000,$0000
        .word $7FFF,$7F78,$7F5A,$7F3D,$7F1F,$771F,$633F,$537E
        .word $4B9C,$4BD9,$57D7,$67D6,$7BB6,$5EF7,$0000,$0000

.include "lw_palette.s"
